<template>
  <div class="kit view page">
    <div class="container">
      <div class="line breadcrumb">
        <breadcrumb
          class="_white"
          :breadcrumbs="breadcrumbs"/>
      </div>
      <div
        v-if="!complete"
        class="request">
        <h1 class="heading title">Зачем вам становиться партнёром сервиса Автоконсьерж GisAuto?</h1>
        <h2 class="heading subtitle">Чтобы получать только реальных клиентов, готовых сделать заказ.</h2>

        <form
          class="ui form"
          @submit.prevent="send">
          <div class="two fields">
            <div
              class="field"
              :class="{invalid: validation.hasError('formData.name')}">
              <div class="input">
                <input
                  class="input-field"
                  type="text"
                  v-model="formData.name"
                  placeholder="Ваше имя">
              </div>
              <div
                v-if="validation.hasError('formData.name')"
                class="error mobilshow">
                {{ validation.firstError('formData.name') }}
              </div>
            </div>
            <div
              class="field"
              :class="{invalid: validation.hasError('formData.email')}">
              <div class="input">
                <input
                  class="input-field"
                  type="email"
                  v-model="formData.email"
                  placeholder="E-mail">
              </div>
              <div
                v-if="validation.hasError('formData.email')"
                class="error mobilshow">
                {{ validation.firstError('formData.email') }}
              </div>
            </div>
          </div>
          <div class="two fields">
            <div
              class="field"
              :class="{invalid: validation.hasError('formData.city')}">
              <AppCitySearch
                v-model="formData.city"
                class="no-checkbox city-concierge"
                :composite="false"
                :placeholder="'Город *'"/>
              <div
                v-if="validation.hasError('formData.city')"
                class="error mobilshow">
                {{ validation.firstError('formData.city') }}
              </div>
            </div>
            <div
              class="field"
              :class="{invalid: validation.hasError('formData.phone')}">
              <phone-input
                v-model="formData.phone"
                :only-mobile="true"
                placeholder="Телефон *"
                autofocus="autofocus"/>
              <div
                v-if="validation.hasError('formData.phone')"
                class="error mobilshow">
                {{ validation.firstError('formData.phone') }}
              </div>
            </div>
          </div>
          <div class="two fields">
            <div class="field btn">
              <button
                type="submit"
                @submit.prevent="send"
                :disabled="loading || actionDisabled || validation.errors.length > 0"
                class="ui button yellow fluid">
                Хочу стать партнером!
              </button>
              <div class="text">
                <span>Нажимая кнопку, вы соглашаетесь на</span>
                <flink
                  href="/about-us/agreement"
                  domain="main"
                  target="_blank"
                  class="link">
                  обработку персональных данных
                </flink>
              </div>
            </div>
          </div>
          <div
            v-if="validation.errors.length > 0"
            v-for="error in validation.errors"
            :key="error.field"
            class="error desktopshow">
            {{ error.message }}
          </div>
        </form>
      </div>

      <div
        v-else
        class="filled">
        <img
          class="img"
          src="~assets/images/check-circular.svg"
          alt="">
        <div class="success">
          <h2 class="title">
            <p>Ваш запрос на&nbsp;партнерство отправлен!</p>
            <p>Мы свяжемся с вами в&nbsp;течение&nbsp;5&nbsp;минут!</p>
          </h2>
        </div>
      </div>


      <ul class="info">
        <li class="info__item phone">
          <a :href="`tel:${trimPhoneNumber($config.contacts.info.phone)}`">{{ $config.contacts.info.phone }}</a>
        </li>
        <li class="info__item clock">05:00 – 18:00 (по МСК)</li>
        <li class="info__item about">
          <flink
            href="/partner/scheme"
            target="_blank"
            @click.native="$ym('partner_more_info')"
            class="link ">
            Подробнее о сотрудничестве
          </flink>
        </li>
      </ul>

    </div>
  </div>
</template>

<script>
import { createNamespacedHelpers } from 'vuex';
import SimpleVueValidation from 'simple-vue-validator';
import { get } from 'lodash-es';

import { SHOW } from '~/assets/js/store/infoModal/action-types';
import Validator from '~/assets/js/validator';
import mapFilters from '~/assets/js/helpers/map-filters';

import PhoneInput from '~/components/redesign/helper/phoneInput';
import Breadcrumb from '~/components/redesign/app-breadcrumbs';
import AppCitySearch from '~/components/redesign/app-input/app-city-search';

const SimpleVueValidator = SimpleVueValidation.Validator.create({
  templates: {
    required: 'Поле обязательно к заполнению.',
    email: 'Введите корректный E-mail',
  },
});

const STORE_INFO_MODAL = createNamespacedHelpers('infoModal');

export default {
  name: 'HelperPartnerPage',
  components: {
    Breadcrumb,
    PhoneInput,
    AppCitySearch,
  },
  mixins: [SimpleVueValidation.mixin],
  data() {
    const formData = {
      name: null,
      phone: null,
      email: null,
      city: null,
    };

    const auth = this.$store.state.user.auth;
    if (auth !== null) {
      formData.email = auth.chatRole !== 'guest' ? auth.username : '';
      formData.name = get(auth, 'userProfile.firstName', '');
      const city = {
        id: get(auth, 'userProfile.city.id', 0),
        name: get(auth, 'userProfile.city.name', ''),
      };
      city.region = get(auth, 'userProfile.city.parent.name', '');
      formData.city = city;
    }

    return {
      loading: false,
      complete: false,
      formData,
      breadcrumbs: [
        {
          url: '',
          name: 'Стать партнером',
        },
      ],
    };
  },
  computed: {
    actionDisabled() {
      return !Validator.checkPhone(this.formData.phone) || !this.formData.city;
    },
  },
  validators: {
    'formData.name'(value) {
      return SimpleVueValidator.value(value)
        .regex(/^[а-яёa-z\s]*$/i, 'Введите корректное имя');
    },
    'formData.phone'(value) {
      return SimpleVueValidator.value(value).required().custom(() => {
        if (!Validator.checkPhone(value)) {
          return 'Введите корректный номер телефона';
        }
        return '';
      });
    },
    'formData.email'(value) { return SimpleVueValidator.value(value).email(); },
    'formData.city'(value) { return SimpleVueValidator.value(value).required(); },
  },
  head() {
    return {
      title: 'Зачем вам становиться партнёром сервиса Автоконсьерж GisAuto?',
      meta: [
        { hid: 'og:title', name: 'og:title', content: 'Зачем вам становиться партнёром сервиса Автоконсьерж GisAuto?' },
        {
          hid: 'description',
          name: 'description',
          content: 'Реальная мотивация для партнеров Автоконсьержа GisAuto - только реальные клиенты,'
            + 'готовые сделать заказ. Оставьте заявку на сайте, станьте партнером и получайте больше клиентов,'
            + 'благодаря нашему сервису. Подробнее о сотрудничестве на сайте.',
        },
        { hid: 'og:url', name: 'og:url', content: `https://${this.$config.domains.main}${this.$route.path}` },
        {
          hid: 'og:description',
          name: 'og:description',
          content: 'Реальная мотивация для партнеров Автоконсьержа GisAuto - только реальные клиенты,'
            + 'готовые сделать заказ. Оставьте заявку на сайте,'
            + 'станьте партнером и получайте больше клиентов,'
            + 'благодаря нашему сервису. Подробнее о сотрудничестве на сайте.',
        },
      ],
      link: [
        { hid: 'canonical', rel: 'canonical', href: `https://${this.$config.domains.helper}${this.$route.path}` },
      ],
    };
  },
  methods: {
    ...mapFilters(['trimPhoneNumber']),
    ...STORE_INFO_MODAL.mapActions({
      showInfo: SHOW,
    }),
    send() {
      this.$validate().then((success) => {
        if (success) {
          this.loading = true;
          this.$axios.$post('/_main/conciergePartnershipRequest/create', {
            data: {
              contactPerson: this.formData.name,
              phone: this.formData.phone,
              email: this.formData.email,
              city: this.formData.city.id,
            },
          }).then(() => {
            this.$ym('partner_form_submit');
            this.complete = true;
          }).catch((e) => {
            this.showError();
            console.log(e);
          }).finally(() => {
            this.loading = false;
          });
        }
      }).catch(e => console.log(e));
    },
    showError() {
      this.showInfo({
        text: 'Временная ошибка, пожалуйста, повторите запрос позднее',
        buttonVisible: false,
      });
    },
  },
};
</script>

<style scoped lang="scss">
  @import "~/assets/scss/modules/_helper-info.scss";
  .line.breadcrumb {
    display: flex;
    flex-flow: row nowrap;
    justify-content: space-between;
    align-items: stretch;
    flex: 0 1 auto;
    margin: 0;
    width: 100%;
    min-height: 1rem;
    padding-top: 1rem;
    background-color: transparent;
    .kit.breadcrumb {
      color: #fff;
      > .divider {
        color: #fff;
      }
    }
    @media only screen and (max-width: 980px) {
      display: none !important;
    }
  }
  .kit.view.page {
    display: flex;
    flex-grow: 1;
    background: url('~assets/images/helper-2-mobile.jpg') center top/cover no-repeat;
    @media only screen and (min-width: 981px) {
      padding:  0 1.5rem 3rem;
      margin: 0;
      background: url('~assets/images/helper-2.jpg') center top/cover no-repeat;
    }

    > .container {
      display: flex;
      flex-flow: column nowrap;
      margin: 0 auto;
      max-width: 60rem;
      @media only screen and (max-width: 980px) {
        max-width: 100%;
      }

      > .request {
        position: relative;
        @media only screen and (min-width: 981px) {
          width: 60rem;
          max-width: 100%;
        }
      }
    }

    .title {
      margin-top: 2.25rem;
      font-weight: 700;
      font-size: 1.6875rem;
      color: #FFCF68;
      @media only screen and (min-width: 981px) {
        margin-top: 3rem;
        font-size: 2.8125rem;
      }
    }

    .subtitle {
      margin: 1.375rem 0 1rem;
      font-weight: 500;
      font-size: 1.0625rem;
      color: #fff;
      @media only screen and (min-width: 981px) {
        font-size: 1.5625rem;
        margin: 0.75rem 0 0;
      }
    }

    .name {
      font-weight: 700;
      color: #4272a4;
      @media only screen and (min-width: 981px) {
        color: #FFCF68;
      }
    }

    .ui.form {
      .link {
        color: inherit;
        font: inherit;
        text-decoration: underline;
      }
      @media only screen and (max-width: 980px) {
        max-width: 23.75rem;
        .fields {
          display: flex;
          flex-flow: column nowrap;
          margin-bottom: 0;
          &.two > .field {
            width: 100%;
            margin: 0 0 .6875rem;
          }
        }
        .text {
          width: auto;
          padding: 1rem 0;
          font-size: 0.8125rem;
          line-height: 1.3;
          color: #fff;
        }
      }
      @media only screen and (min-width: 981px) {
        padding-top: 2.5rem;
        padding-bottom: 2rem;
        width: 100%;
        max-width: 40rem;
        .fields {
          margin-bottom: 0.875rem;
        }
        .text {
          display: block;
          padding-top: 1rem;
          font-size: 0.9375rem;
          line-height: 1.3;
          color: #fff;
        }
      }
    }

    .filled {
      display: flex;
      flex-flow: column nowrap;
      align-items: center;
      padding-top: 2.25rem;
      @media only screen and (min-width: 981px) {
        flex-flow: row nowrap;
        padding-top: 5.625rem;
      }
      .img {
        display: block;
        margin: 0 auto 1rem;
        @media only screen and (min-width: 981px) {
          margin: 0.5rem 1.125rem auto 0;
        }
      }
      .success {
        display: block;
        text-align: center;
        @media only screen and (min-width: 981px) {
          text-align: left;
        }
      }
      .title {
        display: block;
        margin: 0;
        color: #fff;
        font-size: 1.5625rem;
        font-weight: 700;
        line-height: 1.3;
        p {
          font: inherit;
          color: inherit;
          padding: 0 0 1rem 0;
          margin: 0;
        }
        @media only screen and (min-width: 981px) {
          font-size: 2.8125rem;
        }
      }
    }
  }

  .error {
    display: flex;
    padding: 0.5rem 0 0 1rem;
    font: 400 0.75rem Roboto, sans-serif;
    color: #E13C3C;
  }

  .two.fields {
    display: flex;
    margin-left: -0.5rem;
    margin-right: -0.5rem;

    & > .field {
      padding-left: .5rem;
      padding-right: .5rem;
      flex-basis: 50%;
      width: 50%;
    }

    & .ui.button.yellow.fluid {
      width: 100%;
      color: rgb(27, 28, 29);
      background-color: rgb(255, 207, 104);

      &[disabled] {
        opacity: .65!important;
      }
    }
  }

</style>
